unit untMainClient;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  StdCtrls, DBXJSON;

type
  TForm2 = class(TForm)
    btnServer: TButton;
    edtTexto: TEdit;
    IdHTTP1: TIdHTTP;
    btnJSON: TButton;
    procedure btnServerClick(Sender: TObject);
    procedure btnJSONClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  URLServer =
    'http://localhost:8081/Server.RestServerTeste/datasnap/rest/TServerMethods1/EchoString/';

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.btnJSONClick(Sender: TObject);
var
  HttpResult, Result: string;
  JValue: TJSONValue;
  JObj: TJSONObject;
  JPair: TJSONPair;
  JArray: TJSOnArray;
begin
  //Em HttpResul guarda-se o resultado obtido da URL
  HttpResult:= IdHTTP1.Get(URLServer + edtTexto.Text);

  //Obtem-se o JValue a partir do resultado do HttpResult
  JValue:= TJSONObject.ParseJSONValue(TEncoding.ASCII.GetBytes(HttpResult), 0);

  if Assigned(JValue) then
  begin
    try
      //Cast de JValue para JSONObject
      JObj:= JValue as TJSONObject;

      //Obtm-se um JPair
      JPair:= JObj.Get(0);

      //Cast para JSONArray
      JArray:= JPair.JsonValue as TJSOnArray;

      //Pega-se o primeiro elemento do JArray
      Result:= JArray.Get(0).Value;

      //Exibe mensagem
      ShowMessage('Valor retornado: ' + Result);
    finally
      //Libera objeto da memria
      JObj.Free;
    end;
  end;
end;

procedure TForm2.btnServerClick(Sender: TObject);
begin
  // chama o mtodo remoto atravs do IdHTTP
  ShowMessage(IdHTTP1.Get(URLServer + edtTexto.Text));
end;

end.
