unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WideStrings, DBXFirebird, StdCtrls, Buttons, DB, SqlExpr;

type
  TForm1 = class(TForm)
    EMPLOYEE: TSQLConnection;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    ListBox1: TListBox;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  DBXCommon,
  dbxDataExpressMetadataProvider,
  dbxMetaDataProvider;

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  MetaDataTable: TDBXMetaDataTable;
  IDCol: TDBXInt32Column;
  Provider: TDBXDataExpressMetaDataProvider;
begin
  MetaDataTable := TDBXMetaDataTable.Create;
  MetaDataTable.TableName := 'TESTE';

  IDCol := TDBXInt32Column.Create('ID');
  IDCol.Nullable := False;

  MetaDataTable.AddColumn(IDCol);
  MetaDataTable.AddColumn(TDBXUnicodeVarCharColumn.Create('TEXTO', 30));
  MetaDataTable.AddColumn(TDBXDateColumn.Create('DATA'));
  MetaDataTable.AddColumn(TDBXDoubleColumn.Create('D'+IntToStr(Tag)));
  Tag := Tag + 1;

  Provider := TDBXDataExpressMetaDataProvider.Create;
  try
    Provider.Connection := EMPLOYEE.DBXConnection;
    Provider.Open;
    ShowMessage(Provider.MakeCreateTableSql(MetaDataTable.TableStorage, MetaDataTable.ColumnsStorage));
    Provider.CreateTable(MetaDataTable);
  finally
    Provider.Free;
    EMPLOYEE.GetTableNames(Listbox1.Items, FAlse);
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  MetaDataPK: TDBXMetaDataIndex;
  Provider: TDBXDataExpressMetaDataProvider;
begin
  MetaDataPK := TDBXMetaDataIndex.Create;
  MetaDataPK.TableName := 'TESTE';
  MetaDataPk.AddColumn('ID');
  MetaDataPK.IndexName := 'PK_TESTE';
  MetaDataPK.Unique := True;

  Provider := TDBXDataExpressMetaDataProvider.Create;
  try
    Provider.Connection := EMPLOYEE.DBXConnection;
    Provider.Open;
    Provider.CreatePrimaryKey(MetaDataPK);
  finally
    Provider.Free;
    EMPLOYEE.GetTableNames(Listbox1.Items, FAlse);
  end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
var
  Provider: TDBXDataExpressMetaDataProvider;
begin
  Provider := TDBXDataExpressMetaDataProvider.Create;
  try
    Provider.Connection := EMPLOYEE.DBXConnection;
    Provider.Open;
    Provider.DropTable('TESTE')
  finally
    Provider.Free;
    EMPLOYEE.GetTableNames(Listbox1.Items, FAlse);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  EMPLOYEE.Open;
  EMPLOYEE.GetTableNames(Listbox1.Items, FAlse);
end;

end.
