unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WideStrings, DB, SqlExpr, DBXFirebird, FMTBcd, Grids, DBGrids,
  DBClient, Provider, StdCtrls, Buttons, ExtCtrls, DBCtrls, Mask, ImgList,
  DBActns, ActnList, PlatformDefaultStyleActnCtrls, ActnMan, GestureMgr,
  ExtDlgs, JPEG, ComCtrls, Spin, DBXCommon, StrUtils;

type
  TfrmPrincipal = class(TForm)
    DELPHICONFERENCE: TSQLConnection;
    sqlDsCli: TSQLDataSet;
    dspCli: TDataSetProvider;
    cdsCli: TClientDataSet;
    cdsCliCODCLI: TIntegerField;
    cdsCliNOMCLI: TStringField;
    cdsCliNASCLI: TDateField;
    cdsCliSALCLI: TFMTBCDField;
    cdsCliALTCLI: TFMTBCDField;
    cdsCliSITCLI: TStringField;
    cdsCliOBSCLI: TMemoField;
    cdsCliFOTCLI: TBlobField;
    DBGrid1: TDBGrid;
    dsCli: TDataSource;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    Label7: TLabel;
    DBMemo1: TDBMemo;
    Label8: TLabel;
    DBImage1: TDBImage;
    DBNavigator1: TDBNavigator;
    BitBtn1: TBitBtn;
    BalloonHint1: TBalloonHint;
    DBCheckBox1: TDBCheckBox;
    Panel1: TPanel;
    ePesquisa: TButtonedEdit;
    ImageList1: TImageList;
    Label9: TLabel;
    bCarregarFoto: TBitBtn;
    bLimparFoto: TBitBtn;
    pGesture: TPanel;
    GestureManager1: TGestureManager;
    ActionManager1: TActionManager;
    DataSetNext1: TDataSetNext;
    DataSetPrior1: TDataSetPrior;
    DataSetInsert1: TDataSetInsert;
    DataSetPost1: TDataSetPost;
    OpenPictureDialog: TOpenPictureDialog;
    Panel2: TPanel;
    SpinEdit: TSpinEdit;
    bGerarComoQry: TBitBtn;
    bGerarComDBXCommand: TBitBtn;
    Memo1: TMemo;
    p: TProgressBar;
    Label10: TLabel;
    lQry: TLabel;
    lDBXCommand: TLabel;
    bConexao: TBitBtn;
    bBeginTrans: TBitBtn;
    bCommit: TBitBtn;
    bRollback: TBitBtn;
    bSuporteTransacao: TBitBtn;
    sqlDsCliCODCLI: TIntegerField;
    sqlDsCliNOMCLI: TStringField;
    sqlDsCliNASCLI: TDateField;
    sqlDsCliSALCLI: TFMTBCDField;
    sqlDsCliALTCLI: TFMTBCDField;
    sqlDsCliSITCLI: TStringField;
    sqlDsCliOBSCLI: TMemoField;
    sqlDsCliFOTCLI: TBlobField;
    mMonitor: TMemo;
    SQLMonitor: TSQLMonitor;
    procedure BitBtn1Click(Sender: TObject);
    procedure ePesquisaRightButtonClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure DBMemo1KeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1Enter(Sender: TObject);
    procedure DBGrid1Exit(Sender: TObject);
    procedure bLimparFotoClick(Sender: TObject);
    procedure dsCliDataChange(Sender: TObject; Field: TField);
    procedure bCarregarFotoClick(Sender: TObject);
    procedure bGerarComoQryClick(Sender: TObject);
    procedure bGerarComDBXCommandClick(Sender: TObject);
    procedure bConexaoClick(Sender: TObject);
    procedure DELPHICONFERENCEAfterConnect(Sender: TObject);
    procedure DELPHICONFERENCEAfterDisconnect(Sender: TObject);
    procedure bBeginTransClick(Sender: TObject);
    procedure DELPHICONFERENCEBeforeDisconnect(Sender: TObject);
    procedure bSuporteTransacaoClick(Sender: TObject);
    procedure bCommitClick(Sender: TObject);
    procedure bRollbackClick(Sender: TObject);
    procedure SQLMonitorTrace(Sender: TObject; TraceInfo: TDBXTraceInfo;
      var LogTrace: Boolean);
  private
    tr: TDBXTransaction;

    function GenIdComQry(NomeGen: String; ValInc: Integer; qry: TSQLQuery): Integer;
    function GenIdComDBXCommand(NomeGen: String; ValInc: Integer; DBXCmd: TDBXCommand): Integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPrincipal: TfrmPrincipal;

implementation

{$R *.dfm}

function TfrmPrincipal.GenIdComQry(NomeGen: String; ValInc: Integer;
  qry: TSQLQuery): Integer;
begin
  qry.Close;
  qry.SQL.Text := 'select gen_id(' + NomeGen + ', ' + IntToStr(ValInc) + ') as ID' +
                  ' from rdb$database';
  qry.Open;
  result := qry.Fields[0].AsInteger;
  qry.Close;
end;

procedure TfrmPrincipal.SQLMonitorTrace(Sender: TObject;
  TraceInfo: TDBXTraceInfo; var LogTrace: Boolean);
begin
  mMonitor.Lines.Add(TraceInfo.Message);
end;

function TfrmPrincipal.GenIdComDBXCommand(NomeGen: String; ValInc: Integer;
  DBXCmd: TDBXCommand): Integer;
var
  reader: TDBXReader;
begin
  DBXCmd.Close;
  DBXCmd.Text := 'select gen_id(' + NomeGen + ', ' + IntToStr(ValInc) + ') as ID' +
                 ' from rdb$database';
  reader := DBXCmd.ExecuteQuery;
  reader.Next;
  result := reader.Value[0].AsInt64;
  reader.Free; //no se esquea disso!
  DBXCmd.Close;
end;

procedure TfrmPrincipal.bCarregarFotoClick(Sender: TObject);
begin
  if OpenPictureDialog.Execute then
    cdsCliFOTCLI.LoadFromFile(OpenPictureDialog.FileName);
end;

procedure TfrmPrincipal.BitBtn1Click(Sender: TObject);
begin
  if cdsCli.ApplyUpdates(0) <> 0 then
    MessageDlg('No foi possvel gravar os dados!', mtWarning, [mbOK], 0);
end;

procedure TfrmPrincipal.bBeginTransClick(Sender: TObject);
begin
  if DELPHICONFERENCE.InTransaction then
    MessageDlg('J existe uma transao em aberto!', mtWarning, [mbOK], 0)
  else
    tr := DELPHICONFERENCE.BeginTransaction;
end;

procedure TfrmPrincipal.bCommitClick(Sender: TObject);
begin
  if DELPHICONFERENCE.InTransaction then
    DELPHICONFERENCE.CommitFreeAndNil(tr)
  else
    MessageDlg('Nenhuma transao em aberto para aplicar um Commit!',
      mtWarning, [mbOK], 0);
end;

procedure TfrmPrincipal.bConexaoClick(Sender: TObject);
begin
  if DELPHICONFERENCE.Connected then
    DELPHICONFERENCE.Close
  else
    DELPHICONFERENCE.Open;
end;

procedure TfrmPrincipal.bGerarComDBXCommandClick(Sender: TObject);
var
  C: TDBXCommand;
  Ini, Fim: TDateTime;
  i: Integer;
begin
  C := DELPHICONFERENCE.DBXConnection.CreateCommand;
  try
    C.CommandType := TDBXCommandTypes.DbxSQL;

    Memo1.Clear;
    p.Max := SpinEdit.Value;
    Ini := Now;
    for i := 1 to p.Max do
    begin
      Memo1.Lines.Add(IntToStr(GenIdComDBXCommand('gen_codcli', 1, C)));
      p.Position := p.Position + 1;
      Application.ProcessMessages;
    end;
    Fim := Now;
    p.Position := 0;

    lDBXCommand.Caption := FormatDateTime('HH:NN:SS.ZZZ', Fim - Ini);
  finally
    C.Free;
  end;
end;

procedure TfrmPrincipal.bGerarComoQryClick(Sender: TObject);
var
  Q: TSQLQuery;
  Ini, Fim: TDateTime;
  i: Integer;
begin
  Q := TSQLQuery.Create(nil);
  try
    Q.SQLConnection := DELPHICONFERENCE;

    Memo1.Clear;
    p.Max := SpinEdit.Value;
    Ini := Now;
    for i := 1 to p.Max do
    begin
      Memo1.Lines.Add(IntToStr(GenIdComQry('gen_codcli', 1, Q)));
      p.Position := p.Position + 1;
      Application.ProcessMessages;
    end;
    Fim := Now;
    p.Position := 0;

    lQry.Caption := FormatDateTime('HH:NN:SS.ZZZ', Fim - Ini);
  finally
    Q.Free;
  end;
end;

procedure TfrmPrincipal.bLimparFotoClick(Sender: TObject);
begin
  cdsCliFOTCLI.Clear;
end;

procedure TfrmPrincipal.bRollbackClick(Sender: TObject);
begin
  DELPHICONFERENCE.RollbackIncompleteFreeAndNil(tr);
end;

procedure TfrmPrincipal.bSuporteTransacaoClick(Sender: TObject);
begin
  ShowMessage( 'Trasaction Support: ' +
               Ifthen(DELPHICONFERENCE.TransactionsSupported, 'YES', 'NO') + #13 +
               'Multiple Trans. Support: ' +
               Ifthen(DELPHICONFERENCE.MultipleTransactionsSupported, 'YES', 'NO'));
end;

procedure TfrmPrincipal.DBGrid1Enter(Sender: TObject);
begin
  KeyPreview := False;
end;

procedure TfrmPrincipal.DBGrid1Exit(Sender: TObject);
begin
  KeyPreview := True;
end;

procedure TfrmPrincipal.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    if DBGrid1.SelectedIndex = DBGrid1.Columns.Count - 1 then
    begin
      if cdsCli.Eof then
        cdsCli.Append
      else
        cdsCli.Next;
      DBGrid1.SelectedIndex := 0;
    end
    else
      DBGrid1.SelectedIndex := DBGrid1.SelectedIndex + 1;
  end;
end;

procedure TfrmPrincipal.DBMemo1KeyPress(Sender: TObject; var Key: Char);
begin
  Key := UpCase(Key);
end;

procedure TfrmPrincipal.DELPHICONFERENCEAfterConnect(Sender: TObject);
begin
  bConexao.Caption := 'Desconectar';
end;

procedure TfrmPrincipal.DELPHICONFERENCEAfterDisconnect(Sender: TObject);
begin
  if Sender <> Self then
    bConexao.Caption := 'Conectar';
end;

procedure TfrmPrincipal.DELPHICONFERENCEBeforeDisconnect(Sender: TObject);
begin
  while DELPHICONFERENCE.InTransaction do
    DELPHICONFERENCE.CommitFreeAndNil(tr);
end;

procedure TfrmPrincipal.dsCliDataChange(Sender: TObject; Field: TField);
begin
  bCarregarFoto.Enabled := cdsCli.State in dsEditModes;
  bLimparFoto.Enabled := cdsCli.State in dsEditModes;
end;

procedure TfrmPrincipal.ePesquisaRightButtonClick(Sender: TObject);
begin
  if cdsCli.ChangeCount > 0 then
  begin
    case MessageDlg('Existem alteraes pendentes.' + #13 +
        'Deseja grav-las?', mtConfirmation, [mbYes, mbNo, mbCancel], 0, mbYes)
      of
      mrCancel:
        abort;
      mrYes:
        begin
          if cdsCli.ApplyUpdates(0) <> 0 then
          begin
            MessageDlg('No foi possvel gravar os dados!', mtWarning, [mbOK],
              0);
            abort;
          end;
        end;
    end;
  end;

  cdsCli.Close;
  cdsCli.Params[0].AsString := ePesquisa.Text + '%';
  cdsCli.Open;
end;

procedure TfrmPrincipal.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    if ePesquisa.Focused then
    begin
      Key := #0;
      ePesquisaRightButtonClick(ePesquisa);
    end
    else
    begin
      Key := #0;
      Perform(WM_NEXTDLGCTL, 0, 0);
    end;
  end;
end;

end.
