unit uFastScript;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Buttons, fs_synmemo, fs_ipascal, fs_iinterpreter,
   fs_tree, ExtCtrls, fs_iextctrlsrtti, fs_imenusrtti, fs_iclassesrtti,
   fs_icpp, DB, DBTables, fs_idbctrlsrtti, fs_idbrtti, fs_ibdertti;

type
   TForm1 = class(TForm)
      fsScript1: TfsScript;
      fsSyntaxMemo1: TfsSyntaxMemo;
      Panel1: TPanel;
      BitBtn1: TBitBtn;
      BitBtn2: TBitBtn;
      BitBtn3: TBitBtn;
      fsTree1: TfsTree;
      BitBtn4: TBitBtn;
      fsClassesRTTI1: TfsClassesRTTI;
      fsPascal1: TfsPascal;
      BitBtn5: TBitBtn;
      OpenDialog1: TOpenDialog;
      SaveDialog1: TSaveDialog;
      BitBtn6: TBitBtn;
      BitBtn7: TBitBtn;
      fsCPP1: TfsCPP;
      Table1: TTable;
      Table1EmpNo: TIntegerField;
      Table1LastName: TStringField;
      Table1FirstName: TStringField;
      Table1PhoneExt: TStringField;
      Table1HireDate: TDateTimeField;
      Table1Salary: TFloatField;
      fsDBRTTI1: TfsDBRTTI;
      fsBDERTTI1: TfsBDERTTI;
      procedure BitBtn1Click(Sender: TObject);
      procedure BitBtn2Click(Sender: TObject);
      procedure BitBtn3Click(Sender: TObject);
      procedure BitBtn4Click(Sender: TObject);
      procedure BitBtn5Click(Sender: TObject);
      procedure BitBtn6Click(Sender: TObject);
      procedure BitBtn7Click(Sender: TObject);
      procedure AdicionaFuncoes;
      function CallMethod(Instance: TOBject; ClassType: TClass; const MethodName: string;
         var Params: Variant): Variant;
      procedure MinhaProcedure(p1: integer; p2: Integer);
      function MinhaFuncao(var p1: string; p2: Integer = 10): string;

   private
      { Private declarations }
   public
      { Public declarations }
   end;

var
   Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
   fsScript1.Clear;
   fsScript1.Lines := fsSyntaxMemo1.Lines;
   fsScript1.Parent := fsGlobalUnit;
   fsScript1.Lines.Add(fsSyntaxMemo1.Lines.Text);
   AdicionaFuncoes;
   if fsScript1.Compile then
      ShowMessage('Compilado.')
   else
      ShowMessage('Erro: ' + fsScript1.ErrorMsg + ', na linha:coluna ' + fsScript1.ErrorPos);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
   fsScript1.Execute;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
   fsSyntaxMemo1.Lines.Text := 'program ;' + #13 + #13 +
      'begin' + #13 + #13 +
      'end.';
   fsSyntaxMemo1.Refresh;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var x, y, z: Integer;
begin
   x := fsScript1.Variables['var1'];
   y := fsScript1.Variables['var2'];
   z := x + y;
   ShowMessage(IntToStr(z));
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
var x: Integer;
begin
   x := fsScript1.CallFunction('MinhaFuncao', varArrayOf([10, 5]));
   ShowMessage(IntToStr(x));
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
   if SaveDialog1.Execute then
      fsSyntaxMemo1.Lines.SaveToFile(SaveDialog1.FileName + '.pas');
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
begin
   if OpenDialog1.Execute then
      fsSyntaxMemo1.Lines.LoadFromFile(OpenDialog1.FileName);
end;

function TForm1.CallMethod(Instance: TOBject; ClassType: TClass;
   const MethodName: string; var Params: Variant): Variant;
var var_param: string;
begin
   if MethodName = 'MINHAPROCEDURE' then
      minhaProcedure(params[0], params[1])
   else if MethodName = 'MINHAFUNCAO' then begin
      var_Param := Params[0];
      result := minhaFuncao(var_Param, Params[1]);
      Params[0] := var_Param;
   end;
end;

procedure TForm1.AdicionaFuncoes;
begin
   // adiciona um mtodo
   fsScript1.AddMethod('procedure minhaProcedure(p1: integer; p2: Integer)', CallMethod);

   // adiciona uma function
   fsScript1.AddMethod('function minhaFuncao(var p1: String; p2: Integer = 10): String', CallMethod);

   // adiciona o form inteiro ao script
   fsGlobalUnit.AddForm(Form1);
end;

function TForm1.MinhaFuncao(var p1: string; p2: Integer = 10): string;
var param1: string;
begin
   Param1 := p1 + ' (modificado)';
   p1 := Param1;
   Result := P1 + ', ' + IntToStr(p2);
end;

procedure TForm1.MinhaProcedure(p1: integer; p2: Integer);
begin
   ShowMessage(IntToStr(p1 + p2));
end;

end.

